#! /usr/bin/ruby -Ke
# Muse 谷 ݥå PDF ץ
# ƥǥ쥯ȥξ̰Ѥ readme.dvi  make Ƥ¹ԤΤ
# 2ڡܤڡǤʴǵǤˤȤꤷƤ

pdfs = []

system("cp ../readme.dvi .")
system("dvipdfmx readme")
pages = `pdfinfo readme.pdf | gawk '/Pages/ {print $2}'`.chomp.to_i
system("rm readme.pdf")

1.upto(pages) {|n|
  system("dvipdfmx -s #{n} -o #{n}.pdf readme")
  system("ebb #{n}.pdf")
  pdfs << "#{n}.pdf"
}
oddpages = pages % 4
if 0 < oddpages
  (oddpages + 1).upto(4) {
    pdfs << "2.pdf"
  }
end

open("readme-pocket.tex", "w"){|tex|
  tex.write(<<'EOB')
\documentclass[landscape]{jsarticle}
\usepackage[dvipdfm]{graphicx}
\setlength\topmargin{-1in}
\setlength\headsep{0pt}
\setlength\headheight{0pt}
\newdimen\halfwidth
\setlength\halfwidth{.499\paperwidth}
\setlength\oddsidemargin{-1in}
\setlength\textheight\paperheight
\setlength\textwidth\paperwidth
\pagestyle{empty}
\begin{document}
EOB

  while 0 < pdfs.size
    tex.write(<<EOB)
\\noindent
\\includegraphics[width=\\halfwidth]{#{pdfs[3]}}%
\\includegraphics[width=\\halfwidth]{#{pdfs[0]}}

\\noindent
\\includegraphics[width=\\halfwidth]{#{pdfs[1]}}%
\\includegraphics[width=\\halfwidth]{#{pdfs[2]}}

EOB
    4.times{pdfs.delete_at(0)}
  end

  tex.write(<<'EOB')
\end{document}
EOB
} # end of readme-pocket.tex

system("platex readme-pocket")
system("dvipdfmx -l readme-pocket")

# cleanup
system("rm readme.dvi")
1.upto(pages) {|n|
  system("rm #{n}.pdf")
  system("rm #{n}.bb")
}
system("rm readme-pocket.tex readme-pocket.aux readme-pocket.log readme-pocket.dvi")
